
local M = {}

local smoothRandom = 0
local deltaRPM = 0
local lastRPM = 0
local shifting = 0
local lastShifting = 0
local lastGear = 0
local prevGear = 0
local nextGear = 0
local nextGearRatio = 0
local shiftTimer = 0
local rpmNeedle = 0
local rpmNeedleTarget = 0
local smoothThrottle = 0
local transSpeedS = 0
local transTorqueS = 0
local deltaTorque = 0
local lastTorque = 0
local deltaRPM = 0
local lastRPM = 0
local deltaParking = 0
local lastParking = 0


local function updateGFX(dt)
	
	smoothRandom = smoothRandom + (math.random(-100, 100) - smoothRandom) * dt * 5
	deltaRPM = v.data.mainEngine.maxRPM - lastRPM
	lastRPM = v.data.mainEngine.maxRPM
	
	-- gearwhine
	electrics.values['gearwhineV'] = 0.10 + smoothThrottle * 0.10
		
	-- transmission sound
	local transSpeed = math.abs(drivetrain.avgAV)
	transSpeedS = transSpeedS + (transSpeed - transSpeedS) * dt * 8
	local transTorque = math.min(1, math.max(-1, drivetrain.torqueTransmission / 800))
	transTorqueS = transTorqueS + (transTorque - transTorqueS) * dt * 10
	electrics.values['transAccP'] = transSpeedS * 0.015
	if lastGear == -1 then electrics.values['transAccP'] = transSpeedS * 0.030 end
	electrics.values['transAccV'] = transTorqueS/4
	if lastGear ==  4 then electrics.values['transAccV'] = transTorqueS/8 end
	if lastGear == -1 then electrics.values['transAccV'] = transTorqueS/2 + 0.1 end
	electrics.values['transDecP'] = transSpeedS * 0.015
	if lastGear == -1 then electrics.values['transDecP'] = transSpeedS * 0.030 end
	electrics.values['transDecV'] = -transTorqueS/8
	if lastGear ==  4 then electrics.values['transDecV'] = -transTorqueS/12 end
	if lastGear == -1 then electrics.values['transDecV'] = -transTorqueS/2 + 0.1 end

end

-- public interface
M.onInit = onInit
M.onReset = onReset
M.updateGFX = updateGFX

return M